#ifndef ___ARENA_NEWEDITOR_I_H___
#  define ___ARENA_NEWEDITOR_I_H___

/*
 * Header file for internal use in "neweditor.c". Publics go to "neweditor.h".
 */

#include "types.h"
#include "neweditor.h"

struct Arena_EditorBufferCell_
{
 char *bank;
 struct Arena_EditorBufferCell_ *next;
 struct Arena_EditorBufferCell_ *prev;
 int size;
 int capacity;
};


#define BANK_SIZE 511
#define SPLIT_SIZE 128


extern cell *CreateCell(int capacity);
extern void FreeCell(cell *);
extern Bool SplitCell(cell *, int split_size);
extern Bool MergeCell(cell *);



#endif /* ifndef ___ARENA_NEWEDITOR_I_H___ */
