#ifndef ___ARENA_PNG_I_H___
#  define ___ARENA_PNG_I_H___

/* Header for Arena "png.c" internal use.
 * Public declarations can be found in "png_arena.h"
 */

#include "arena.h"

#include "image_types.h"


typedef enum { ARENA_PNG_IMAGE_EMPTY,
	       ARENA_PNG_IMAGE_OLD,
	       ARENA_PNG_IMAGE_CHANGED,
	       ARENA_PNG_IMAGE_FINISHED } Arena_PNG_image_status;

typedef struct Arena_PNG_ptr_info_struct
{
 png_structp png_ptr;
 png_infop info_ptr;
 png_bytep png_image;
 Arena_PNG_image_status image_status;
} Arena_PNG_struct;


ImageData* ReadPNGimage_1_2_4(png_struct *, png_info *, png_byte *); 
ImageData* ReadPNGimage_24(png_struct *, png_info *, png_byte *); 
ImageData* ReadPNGimage_16(png_struct *, png_info *, png_byte *); 

ImageData* ReadPNGimage(png_struct *, png_info *, png_byte *); 


#endif /* ifndef ___ARENA_PNG_H___ */
